#include <stdlib.h>

#include "./ivec_ext.h"

void ivec_filter(IntVec* xs, bool (*f)(int)) {
  for (size_t i = ivec_length(xs); i > 0; ) {
    i--;
    if (!f(*ivec_at(xs, i))) {
      ivec_remove(xs, i);
    }
  }
}

int ivec_fold(IntVec* xs, int y, int (*f)(int, int)) {
  for (size_t i = 0; i < ivec_length(xs); ++i) {
    y = f(y, *ivec_at(xs, i));
  }
  return y;
}

int add(int x, int y) {
  return x + y;
}

int mul(int x, int y) {
  return x * y;
}

int ivec_sum(IntVec* xs) {
  return ivec_fold(xs, 0, add);
}

int ivec_product(IntVec* xs) {
  return ivec_fold(xs, 1, mul);
}
