#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <string.h>
#include <math.h>

#include "../tui/tui.h"
#include "./plot_lib.h"

double moving_sin(double x, double t) {
  return sin(x - t);
}

double moving_cos(double x, double t) {
  return cos(x - t * 2);
}

double moving_weird(double x, double t) {
  return sin(x - t * 2) * tan(x - t * 3);
}

double moving_weird_2(double x, double t) {
  return sin(x - t * 2) * sin(x*x - t * 3);
}

int main(void) {
  Function functions[] = {
    { .f = moving_sin, .fg_color = FG_RED, .bg_color = BG_BLACK },
    { .f = moving_cos, .fg_color = FG_GREEN, .bg_color = BG_BLACK },
    { .f = moving_weird, .fg_color = FG_BLUE, .bg_color = BG_BLACK },
    { .f = moving_weird_2, .fg_color = FG_YELLOW, .bg_color = BG_BLACK }
  };

  Settings settings = {
    .x_min = 0.0,
    .x_max = 10.0,
    .y_min = -2.0,
    .y_max = 2.0
  };

  plot(&settings, functions, 4);

  return 0;
}
